'
' Configure the settings in the XML-based *.config files for each of the
' programs in the SOSOS suite.  Handles the encryption of the connection
' strings inside the config file.
'
Public Class fmMain

    Private fmCfg As fmConfigure

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim prog As String

        For Each prog In My.Settings.ProgramList
            cmbProgram.Items.Add(prog)
        Next
        cmbProgram.Text = "SOSOS"
    End Sub

    Private Sub bnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnQuit.Click
        Close()
    End Sub

    '
    ' We turn off the features that are not appropriate for that program
    '
    Private Sub cmbProgram_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbProgram.TextChanged
        Dim c As Control
        fmCfg = New fmConfigure

        Select Case cmbProgram.Text
            Case "SOSOS"
                For Each c In fmCfg.tpOther.Controls
                    c.Enabled = False
                Next
            Case "MgmtConsoleSOSOS"
                fmCfg.bnErrLogFile.Enabled = False
                fmCfg.bnLogDir.Enabled = False
                fmCfg.bnPollByFile.Enabled = False
                fmCfg.bnPollFile.Enabled = False
                fmCfg.cbDefaultDoDetails.Enabled = False
                fmCfg.cbUsePing.Enabled = False
                fmCfg.cmbDefaultView.Enabled = False
                fmCfg.cmbErrLogLevel.Enabled = False
                fmCfg.cmbPollLogLevel.Enabled = False
                fmCfg.cmbPollMethod.Enabled = False
                fmCfg.nudByAge.Enabled = False
                fmCfg.nudEventsByDays.Enabled = False
                fmCfg.nudEventsByLines.Enabled = False
                fmCfg.nudPollTimeout.Enabled = False
                fmCfg.tbErrLogFile.Enabled = False
                fmCfg.tbFileInfoList.Enabled = False
                fmCfg.tbLastLoginFile.Enabled = False
                fmCfg.tbPollByFileFile.Enabled = False
                fmCfg.tbPollLogDir.Enabled = False
                fmCfg.tbPollLogFile.Enabled = False
                fmCfg.tbRegistryList.Enabled = False
                fmCfg.tbSUS_Server.Enabled = False
                fmCfg.tbVersionFile.Enabled = False
                For Each c In fmCfg.tpSelection.Controls
                    c.Enabled = False
                Next
            Case "RunSOSOS"
                For Each c In fmCfg.tpPolling.Controls
                    c.Enabled = False
                Next
                For Each c In fmCfg.tpOther.Controls
                    c.Enabled = False
                Next
                For Each c In fmCfg.tpUser.Controls
                    c.Enabled = False
                Next
            Case "PollSOSOS"
                fmCfg.cmbGenerate.Enabled = False
                fmCfg.bnRunSOSOS.Enabled = False
                fmCfg.bnViewSOSOS.Enabled = False
                fmCfg.cmbListView.Enabled = False
                fmCfg.tbRunSOSOS.Enabled = False
                fmCfg.tbViewSOSOS.Enabled = False
                For Each c In fmCfg.tpUser.Controls
                    c.Enabled = False
                Next
            Case "ViewSOSOS"
                fmCfg.bnErrLogFile.Enabled = False
                fmCfg.bnLogDir.Enabled = False
                fmCfg.cbUsePing.Enabled = False
                fmCfg.cmbErrLogLevel.Enabled = False
                fmCfg.tbDomain.Enabled = False
                fmCfg.tbErrLogFile.Enabled = False
                fmCfg.tbLastLoginFile.Enabled = False
                fmCfg.tbNameFilter.Enabled = False
                fmCfg.tbOUFilter.Enabled = False
                For Each c In fmCfg.tpPolling.Controls
                    c.Enabled = False
                Next
                For Each c In fmCfg.tpSettings.Controls
                    c.Enabled = False
                Next
                For Each c In fmCfg.tpOther.Controls
                    c.Enabled = False
                Next
        End Select
    End Sub

    '
    ' Display the Configure window.  It handles all of the real work.
    '
    Private Sub bnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnOK.Click
        If tbConfigPath.Text = "" Then
            MsgBox("The path to the executable file is not optional", MsgBoxStyle.Exclamation, "Missing input")
            Exit Sub
        End If

        Try
            fmCfg.Text = "Configure " & cmbProgram.Text
            fmCfg.LoadDefaults(tbConfigPath.Text, cmbProgram.Text)
            fmCfg.ShowDialog()
        Catch ex As Exception
            MsgBox("Could not load configuration file" & vbCr & ex.Message, MsgBoxStyle.Exclamation, "Error")
        End Try

    End Sub

    '
    ' Browse for the exe file
    '
    Private Sub bnFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnFile.Click
        OpenFileDialog1.FileName = tbConfigPath.Text
        OpenFileDialog1.Filter = "Configuration files (*.config)|*.config"
        OpenFileDialog1.CheckFileExists = True
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbConfigPath.Text = OpenFileDialog1.FileName
        End If
    End Sub
End Class
